/****************************************************************************
 Include Section
*****************************************************************************/

#include "configurations.h"
#include "global.h"
#include "BfCacheTest.h"


#if defined __ICACHETEST__

/*****************************************************************************
 Symbolic constants / definitions
******************************************************************************/

/*****************************************************************************
 Variables
******************************************************************************/

/*****************************************************************************
 Prototypes
******************************************************************************/

.GLOBAL _BfIcacheTest;

/*****************************************************************************
 Functions
******************************************************************************/

.SECTION L1_code;


/****************************************************************************
 Name:                  _BfIcacheTest
 Description:           
 Input Parameters:      none
 Return Parameters:     none
 Registers Used:        R7:0,P5:0,Loopreg
 Global Registers Used: none
 C-Callable :           no
*****************************************************************************/

_BfIcacheTest:
    link 0;
    [--SP] = ASTAT;
    [--SP] = (R7:0,P5:0);
    PUSH_LOOP_REGx(0);


    IMM32(P0,EXT_A);
    IMM32(P1,EXT_B);
    IMM32(P2,EXT_C);
    IMM32(P3,EXT_D);
    IMM32(P4,EXT_E);

    IMM32(P5,ITERATIONS);
    
    IFLUSH[P0];IFLUSH[P1];IFLUSH[P2];IFLUSH[P3];IFLUSH[P4];

    lsetup(lp0.t,lp0.b) LC0 = P5;
    lp0.t:  call(P0);
            call(P1);
            call(P2);
    lp0.b:  call(P3);

    call(P4); // Cache-Line Fill: replace EXT_A by EXT_E in CL0 WAY0


    POP_LOOP_REGx(0);
    (R7:0,P5:0) = [SP++];
    ASTAT = [SP++];
    unlink;
    rts;
_BfIcacheTest.end:


#endif /* defined __ICACHETEST__ */

/*****************************************************************************
 EOF
******************************************************************************/
